From 1e772df8a23bcb887ae62bfb6c6cdbdc1892bc35 Mon Sep 17 00:00:00 2001
From: Matej Habrnal <mhabrnal@redhat.com>
Date: Fri, 6 Mar 2015 02:44:27 +0100
Subject: [PATCH] reporter-mantisbt: changes related to reporter-mantisbt

Signed-off-by: Matej Habrnal <mhabrnal@redhat.com>
---
 ...-run-the-reporter-bugzilla-h-on-RHEL-and-.patch | 29 +++++++++++++++
 .../0090-plugin-set-URL-to-retrace-server.patch    | 42 ++++++++++++++++++++++
 SPECS/abrt.spec                                    | 15 +++++---
 3 files changed, 81 insertions(+), 5 deletions(-)
 create mode 100644 SOURCES/0088-event-don-t-run-the-reporter-bugzilla-h-on-RHEL-and-.patch
 create mode 100644 SOURCES/0090-plugin-set-URL-to-retrace-server.patch

diff --git a/SOURCES/0088-event-don-t-run-the-reporter-bugzilla-h-on-RHEL-and-.patch b/SOURCES/0088-event-don-t-run-the-reporter-bugzilla-h-on-RHEL-and-.patch
new file mode 100644
index 0000000..334986f
--- /dev/null
+++ b/SOURCES/0088-event-don-t-run-the-reporter-bugzilla-h-on-RHEL-and-.patch
@@ -0,0 +1,29 @@
+From 6c95ae2bf1c80530442a516f23b7cd8e82dcae12 Mon Sep 17 00:00:00 2001
+From: Matej Habrnal <mhabrnal@redhat.com>
+Date: Thu, 22 Jan 2015 02:23:21 +0100
+Subject: [PATCH 88/91] event: don't run the 'reporter-bugzilla -h' on RHEL and
+ CentOS
+
+Running the 'reporter-bugzilla -h' makes sense only on Fedora because of bodhi.
+
+Signed-off-by: Matej Habrnal <mhabrnal@redhat.com>
+---
+ src/plugins/ccpp_event.conf | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/plugins/ccpp_event.conf b/src/plugins/ccpp_event.conf
+index 62ff08a..cd75ee2 100644
+--- a/src/plugins/ccpp_event.conf
++++ b/src/plugins/ccpp_event.conf
+@@ -71,7 +71,7 @@ EVENT=analyze_LocalGDB analyzer=CCpp
+         # Run GDB plugin to see if crash looks exploitable
+         abrt-action-analyze-vulnerability
+         # Run GDB to genereate backtrace
+-        abrt-action-analyze-ccpp-local --without-bodhi
++        abrt-action-analyze-ccpp-local --without-bz
+ 
+ 
+ # Bugzilla requires nonempty duphash
+-- 
+1.8.3.1
+
diff --git a/SOURCES/0090-plugin-set-URL-to-retrace-server.patch b/SOURCES/0090-plugin-set-URL-to-retrace-server.patch
new file mode 100644
index 0000000..b2dc31a
--- /dev/null
+++ b/SOURCES/0090-plugin-set-URL-to-retrace-server.patch
@@ -0,0 +1,42 @@
+From 81181a893b91a229e05a5a915cc98347126e3834 Mon Sep 17 00:00:00 2001
+From: Matej Habrnal <mhabrnal@redhat.com>
+Date: Fri, 30 Jan 2015 17:52:25 +0100
+Subject: [PATCH 90/91] plugin: set URL to retrace server
+
+Changed default retrace server URL from localhost to retrace.fedoraproject.org.
+
+Signed-off-by: Matej Habrnal <mhabrnal@redhat.com>
+---
+ src/plugins/analyze_CCpp.xml.in          | 2 +-
+ src/plugins/analyze_RetraceServer.xml.in | 2 +-
+ 2 files changed, 2 insertions(+), 2 deletions(-)
+
+diff --git a/src/plugins/analyze_CCpp.xml.in b/src/plugins/analyze_CCpp.xml.in
+index 6f02692..a7ce4dd 100644
+--- a/src/plugins/analyze_CCpp.xml.in
++++ b/src/plugins/analyze_CCpp.xml.in
+@@ -26,7 +26,7 @@
+     <options>
+         <option type="text" name="RETRACE_SERVER_URL">
+            <_label>Retrace server URL</_label>
+-           <default-value>localhost</default-value>
++           <default-value>retrace.fedoraproject.org</default-value>
+            <allow-empty>no</allow-empty>
+            <_description>Address of the retrace server</_description>
+        </option>
+diff --git a/src/plugins/analyze_RetraceServer.xml.in b/src/plugins/analyze_RetraceServer.xml.in
+index cf1d25a..e437cac 100644
+--- a/src/plugins/analyze_RetraceServer.xml.in
++++ b/src/plugins/analyze_RetraceServer.xml.in
+@@ -12,7 +12,7 @@
+     <options>
+         <option type="text" name="RETRACE_SERVER_URL">
+            <_label>Retrace server URL</_label>
+-           <default-value>localhost</default-value>
++           <default-value>retrace.fedoraproject.org</default-value>
+            <allow-empty>no</allow-empty>
+            <_description>Address of the retrace server</_description>
+        </option>
+-- 
+1.8.3.1
+
diff --git a/SPECS/abrt.spec b/SPECS/abrt.spec
index 5c095c3..187eac5 100644
--- a/SPECS/abrt.spec
+++ b/SPECS/abrt.spec
@@ -33,7 +33,7 @@
 Summary: Automatic bug detection and reporting tool
 Name: abrt
 Version: 2.1.11
-Release: 19%{?dist}
+Release: 20%{?dist}
 License: GPLv2+
 Group: Applications/System
 URL: https://fedorahosted.org/abrt/
@@ -125,6 +125,10 @@ Patch82: 0082-translations-pull-the-newest-PO-files.patch
 #Patch85: 0085-zanata-add-gettext-mappings.patch
 Patch86: 0086-translations-update-the-PO-files.patch
 Patch87: 0087-abrt-auto-reporting-make-the-code-more-safer.patch
+Patch88: 0088-event-don-t-run-the-reporter-bugzilla-h-on-RHEL-and-.patch
+#Patch89: 0089-spec-added-dependency-to-libreport-centos.patch
+Patch90: 0090-plugin-set-URL-to-retrace-server.patch
+#Patch91: 0091-spec-add-dependenci-on-abrt-retrace-client.patch
 
 Patch1000: 1000-turn-sosreport-off.patch
 
@@ -234,10 +238,8 @@ Group: System Environment/Libraries
 Requires: cpio
 Requires: gdb >= 7.6.1-63
 Requires: elfutils
-%if 0%{!?rhel:1}
 # abrt-action-perform-ccpp-analysis wants to run analyze_RetraceServer:
 Requires: %{name}-retrace-client
-%endif
 Requires: %{name} = %{version}-%{release}
 Requires: abrt-libs = %{version}-%{release}
 Requires: libreport-python
@@ -350,7 +352,7 @@ Requires: abrt-addon-ccpp
 Requires: abrt-addon-python
 Requires: abrt-addon-xorg
 %if 0%{?rhel}
-Requires: libreport-rhel >= %{libreport_ver}
+Requires: libreport-centos >= %{libreport_ver}
 Requires: libreport-plugin-rhtsupport >= %{libreport_ver}
 %else
 Requires: abrt-retrace-client
@@ -384,7 +386,7 @@ Requires: elfutils
 Requires: abrt-gui
 Requires: gnome-abrt
 %if 0%{?rhel}
-Requires: libreport-rhel >= %{libreport_ver}
+Requires: libreport-centos >= %{libreport_ver}
 Requires: libreport-plugin-rhtsupport >= %{libreport_ver}
 %else
 Requires: abrt-retrace-client
@@ -993,6 +995,9 @@ gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
 %config(noreplace) %{_sysconfdir}/profile.d/abrt-console-notification.sh
 
 %changelog
+* Mon Mar 09 2015 Matej Habrnal <mhabrnal@redhat.com - 2.1.11-20
+- set URL to retrace server
+
 * Thu Mar 05 2015 CentOS Sources <bugs@centos.org> - 2.1.11-19.el7.centos
 - Drop RHTS hint
 -  Change by David Mansfield <david@orthanc.cobite.com>
-- 
1.8.3.1